//---------------------------------------------------------------------------
#ifndef BarRemsDlgsH
#define BarRemsDlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <CheckLst.hpp>
#include <ImgList.hpp>

#include "StatsWins4.h"
#include <Menus.hpp>
//---------------------------------------------------------------------------
bool __fastcall ManageBarredRemailers(TQSStatsWin4 *Owner, const AnsiString &FileName);

class TBarRemsDlg : public TForm
{
__published:	// IDE-managed Components
        TBevel *Bevel1;
        TButton *OkBtn;
        TButton *CancelBtn;
        TTreeView *TreeView;
        TButton *EditSrcBtn;
        TLabel *Label1;
        TPopupMenu *PopupMenu1;
        TMenuItem *PopBarredLastItem;
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall TreeViewMouseDown(TObject *Sender,
           TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall TreeViewCustomDrawItem(TCustomTreeView *Sender,
           TTreeNode *Node, TCustomDrawState State, bool &DefaultDraw);
        void __fastcall EditSrcBtnClick(TObject *Sender);
        void __fastcall PopBarRemailerLastItem(TObject *Sender);
        void __fastcall PopupMenu1Popup(TObject *Sender);
private:	// User declarations
public:		// User declarations
        TTreeNode *mnode;
        AnsiString BarFile, OrgBars;
        TStringList *AllRemailers, *BarredRemailers, *BarredLast;
        bool Modified;

        __fastcall virtual TBarRemsDlg(TComponent* Owner);
        __fastcall virtual TBarRemsDlg(TComponent* Owner, const AnsiString &FileName);
        __fastcall virtual~TBarRemsDlg();

        void __fastcall GetBarredFromTreeView(TStrings *Barred);
        void __fastcall GetMixmasterRemailers(TStrings *mixers);
        bool __fastcall NodeRemailerExists(TTreeNode *Node);
        bool __fastcall IsChecked(TTreeNode *node);
        void __fastcall LoadTreeView();
};

//---------------------------------------------------------------------------
extern PACKAGE TBarRemsDlg *BarRemsDlg;
//---------------------------------------------------------------------------
#endif
