//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <mshtml.h>

#include "Global2.h"
#include "StatsWins2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SHDocVw_OCX"
#pragma resource "*.dfm"
TStatsWin2 *StatsWin2;
//---------------------------------------------------------------------------

void __fastcall DownloadURL(TForm *Owner, const AnsiString &Title, const AnsiString &URL,
   bool AutoSave)
{
   StatsWin2 = new TStatsWin2(Owner);
   StatsWin2->GetURL(Title, URL, AutoSave);
}

//---------------------------------------------------------------------------
// TStatsWin2
//---------------------------------------------------------------------------

__fastcall TStatsWin2::TStatsWin2(TComponent* Owner)
        : TForm(Owner)
{
   CancelBtn->Left = GetBtn->Left;
   CancelBtn->Top = GetBtn->Top;
   CancelBtn->Visible = false;
   GotError = false;
   Cancel = false;
}
//---------------------------------------------------------------------------
#pragma argsused
void __fastcall TStatsWin2::FormClose(TObject *Sender, TCloseAction &Action)
{
   Application->MainForm->Close();
   Action = caFree;
}
//---------------------------------------------------------------------------
#pragma argsused
void __fastcall TStatsWin2::CancelBtnClick(TObject *Sender)
{
   GetBtn->Visible = true;
   CancelBtn->Visible = false;
   Timer1->Enabled = false;
   if (Browser->Busy) Browser->Stop();
   Cancel = true;
   Caption = Cap;
}
//---------------------------------------------------------------------------
#pragma argsused
void __fastcall TStatsWin2::FileOpenItemClick(TObject *Sender)
{
   if (Caption.IsEmpty() || URLBox->Text.IsEmpty())
      return;

   CancelBtn->Visible = true;
   SaveBtn->Enabled = false;
   GetBtn->Visible = false;
   GotError = false;
   Cancel = false;

   Cap = Caption;
   Caption = "Loading...";
   Timer1->Enabled = true;
   Browser->Navigate(WideString(URLBox->Text));
}
//---------------------------------------------------------------------------

AnsiString GetPlainText(TCppWebBrowser *Browser )
{
   AnsiString SourceBody;
   IHTMLDocument2 *HTMLDocument = NULL;

   if(SUCCEEDED(Browser->Document->QueryInterface(IID_IHTMLDocument2, (LPVOID*)&HTMLDocument)))
   {
      IHTMLElement *HTMLBody = NULL;
      if(SUCCEEDED(HTMLDocument->get_body(&HTMLBody)))
      {
          BSTR Sourcebody;
          if(SUCCEEDED(HTMLBody->get_innerText(&Sourcebody)))
        //if(SUCCEEDED(HTMLBody->get_outerText(&Sourcebody)))
             SourceBody = Sourcebody;

          HTMLBody->Release();
      }
      HTMLDocument->Release();
   }
   return SourceBody;
}
//---------------------------------------------------------------------------

bool __fastcall IsValidPage(const AnsiString &PageName, const AnsiString &PageText,
   AnsiString &ErrorMsg)
{
   if (PageName.Pos("mlist.txt"))
   {
      if (PageText.Pos("Stats-Version: 2") > 0)
      {
         ErrorMsg = "You have downloaded version 2 stats, but you need version 1";
         return false;
      }
      if (PageText.Pos("mixmaster           history  latency  uptime") == 0)
      {
         ErrorMsg = "The document you have downloaded is not a valid mlist.txt";
         return false;
      }
      return true;
   }

   if (PageName == "pubring.mix")
   {
      if (PageText.Pos("-----Begin Mix Key-----") == 0)
      {
         ErrorMsg = "The document you've downloaded is not a valid pubring.mix";
         return false;
      }
      return true;
   }

   if (PageName == "type2.list")
   {
      return true;
   }

   if (PageName == "rlist.txt")
   {
      if (PageText.Pos("Stats-Version: 2") > 0)
      {
         ErrorMsg = "You have downloaded version 2 stats, but you need version 1";
         return false;
      }
      if (PageText.Pos("remailer  email address                        history  latency  uptime") == 0)
      {
         ErrorMsg = "The document you have downloaded is not a valid rlist.txt";
         return false;
      }
      return true;
   }
   if (PageName == "pubring.asc")
   {
      if (PageText.Pos("-----BEGIN PGP PUBLIC KEY BLOCK-----") == 0)
      {
         ErrorMsg = "The document you have downloaded is not a valid rlist.txt";
         return false;
      }
      return true;
   }
   return true;
}
//---------------------------------------------------------------------------
#pragma argsused
void __fastcall TStatsWin2::FileSaveItemClick(TObject *Sender)
{
   AnsiString text = GetPlainText(Browser);
   if (text != "")
   {
      TStringList *filetext = new TStringList();
      filetext->Text = text;
      filetext->SaveToFile(Caption);
      delete filetext;
   }
}
//---------------------------------------------------------------------------
#pragma argsused
void __fastcall TStatsWin2::Timer1Timer(TObject *Sender)
{
   if (Caption.IsEmpty()) Caption = "Loading...";
   else Caption = "";
}
//---------------------------------------------------------------------------
#pragma argsused
void __fastcall TStatsWin2::BrowserNavigateError(TObject *Sender,
      LPDISPATCH pDisp, Variant *URL, Variant *Frame, Variant *StatusCode,
      VARIANT_BOOL *Cancel)
{
   GotError = true;
}
//---------------------------------------------------------------------------
#pragma argsused
void __fastcall TStatsWin2::BrowserDownloadComplete(TObject *Sender)
{
   ActiveControl = Browser;
   SaveBtn->Enabled = !GotError;
   Timer1->Enabled = false;
   CancelBtn->Visible = false;
   GetBtn->Visible = true;
   Caption = Cap;
   Timer2->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TStatsWin2::GetURL(const AnsiString &FileName, const AnsiString &URLName,
   bool autosave)
{
   Caption = FileName;
   URLBox->Text = URLName;
   AutoSave = autosave;
   Show();
   Snooze(200);
   FileOpenItem->Click();
}
//---------------------------------------------------------------------------
#pragma argsused
void __fastcall TStatsWin2::GetBtnClick(TObject *Sender)
{
   FileOpenItem->Click();
}
//---------------------------------------------------------------------------
#pragma argsused
void __fastcall TStatsWin2::Exit1Click(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------
#pragma argsused
void __fastcall TStatsWin2::Timer2Timer(TObject *Sender)
{
   Timer2->Enabled = false;
   if (!Cancel && !GotError)
   {
      FileSaveItem->Click();
      Close();
   }
}
//---------------------------------------------------------------------------

